
#define SELFTEST

/*
    This source belongs to CAD vectorial fonts package Ver 3.0, developed 
    by Jorge Estevez. and Lazaro. M. Glez. 
    
    This file is the source code for the demo program
    Please feel free to copy the executable demo file, this source file and 
    the vectorial font files that comes with the demo package without
    modifications.
    
    readme.txt has information of interest
    
*/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "bios.h"
#include "conio.h"
#include "math.h"
#include "malloc.h"
#include "graph.h"
#include "dos.h"

#include "..\include\fontlib.h"
#include "dos.h"


/* internal demo's global definitions */
size_t FontFileLength;
char *BufferFonts;
int reserved;

/*Defining a seltest style for test only */
struct TextStyle Normal={ "Normal",          /* Left justified */      
                          "classic4.fnt",     
                           0.0,
                           1.0,
                           0.0,
                           FALSE,
                           FALSE,
                           FALSE};
                           


int ginitgraphics(void);
int inittextmode(void);
void PutDisplay(void);
int tg_getmaxy(void); 
int FontFileExists(char *FontFile);
size_t FontFileSize(char *FontFile);


#define MAX_NUM_PRIMITIVES_FILE 2000
struct primitivefile Display[MAX_NUM_PRIMITIVES_FILE];
unsigned long DisplayIndex=0;

TEXTOUPUTSTATE  OuttextState;  /* structure returned by Text() function */
#define DisplayIndex (OuttextState.LastPrimitiveIndex)

/*------------------------------------------------------------------------*/
void main(void);
void main(void)
{
   int Com;
   char Str[80];
   char FileName[13];
   DOUBLE Hei, Ang;
   FONT_JUSTIFICATION Just;
   RW_POINT Pt1;
   RW_POINT Pt2;


    /* reservo para siplex.fnt que es el default */

    if(FontFileExists(Normal.FontFile))
      FontFileLength=FontFileSize(Normal.FontFile);
    if((BufferFonts=( char *) calloc(sizeof( char),(size_t)FontFileLength))==NULL)
      {
      cputs("NO Memory in text for bufferfonts \r\r\n");
      exit(0);
      }
      else
     reserved=TRUE;



   cputs("\r\n\r\nVectorial Font Demo #2");
   cputs("\r\n\r\nHit any key to begin...(Esc ends execution)\r\n ");
   Com=getch();
   if(Com==27)
     exit(1);                                               
   cputs("\r\n------------------------------------------------------------");    
   cputs("\r\nPlease choose a .fnt vectorial font file ");  
   cputs("\r\nWould you like to use any other than monotxt.fnt ? (Y/N) <N>");
   Com=getch();

   if(Com=='Y'||Com=='y')
     {
     cputs("\r\nEnter the Full File Name : ");
      scanf("%s",FileName);
     strcpy(Normal.FontFile,FileName);

    if(reserved==TRUE)
      free((void*)BufferFonts);

    if(FontFileExists(Normal.FontFile))
      FontFileLength=FontFileSize(Normal.FontFile);
    if((BufferFonts=( char *) calloc(sizeof( char),(size_t)FontFileLength))==NULL)
      {
      cputs("NO Memory in text for bufferfonts \r\r\n");
      exit(0);
      }
      else
     reserved=TRUE;

     }
    cputs("\r\nWould you like to place it in vertical way ? (Y/N) <N>");
    Com=getch();
   if(Com=='Y'||Com=='y')
     {
      Normal.Orient=TRUE;
     }
   
   UserSetPF(Display , MAX_NUM_PRIMITIVES_FILE);   
   
   if(InitStyle(Normal,BufferFonts,FontFileLength)!=OK)
     {   /*if an Error were ocurred */
     cputs("\r\nImpossible to Open Font File or Not Enough Memory");
     exit(1);
     }               
   
   do{
      cputs("\r\n\r\nStart point or Align/Center/Fit/Middle/Right/Style(t):<Start point>");
      Com=getch();

      switch(Com)
        {
         case 'a':
         case 'A':
               cputs("\r\nAligned Text ");  
               cputs("\r\nText Line Start Point (e.g 10,10): ");
               scanf("%lf,%lf",&Pt1.x,&Pt1.y);
               cputs("\r\nText Line End Point (e.g 100,100) : ");
               scanf("%lf,%lf",&Pt2.x,&Pt2.y);
               cputs("\r\nText to display: ");
               fflush(stdin);
               gets(Str);
               /*Set Just automatically to Left Justified or Default */
               Just=ALIGNED;
               break;
         case 'F':
         case 'f':                          
               cputs("\r\nFitted Text ");  
               cputs("\r\nText Line Start Point (e.g 10,10): ");
               scanf("%lf,%lf",&Pt1.x,&Pt1.y);
               cputs("\r\nText Line End Point (e.g 100,100) : ");
               scanf("%lf,%lf",&Pt2.x,&Pt2.y);
               cputs("\r\nHeight (Bigger than 0) : ");
               scanf("%lf",&Hei);
               cputs("\r\nText to display: ");
               fflush(stdin);
               gets(Str);
               /*Set Just automatically to Left Justified or Default */
               Just=FIT;
               break;
         case 'c':
         case 'C':                                     
               cputs("\r\nCentered Text ");  
               cputs("\r\nText Line Center Point (e.g 100,100) : ");
               scanf("%lf,%lf",&Pt1.x,&Pt1.y);
               cputs("\r\nHeight (Bigger than 0) : ");
               scanf("%lf",&Hei);
               cputs("\r\nRotation Angle (0 to 359): ");
               scanf("%lf",&Ang);
               cputs("\r\nText to display: ");
               fflush(stdin);
               gets(Str);
               /*Set Just automatically to Left Justified or Default */
               Just=CENTERED;
               break;
         case 'M':
         case 'm':                                     
               cputs("\r\nMidle text");  
               cputs("\r\nText Line Middle Point (e.g 10,10) : ");
               scanf("%lf,%lf",&Pt1.x,&Pt1.y);
               cputs("\r\nHeight (Bigger than 0) : ");
               scanf("%lf",&Hei);
               cputs("\r\nRotation Angle (0 to 359): ");
               scanf("%lf",&Ang);
               cputs("\r\nText to display: ");
               fflush(stdin);
               gets(Str);
               /*Set Just automatically to Left Justified or Default */
               Just=MIDDLE;
               break;
         case 'r':
         case 'R':
               cputs("\r\nRigth Justified Text ");  
               cputs("\r\nText Line End Point (e.g 100,100) : ");
               scanf("%lf,%lf",&Pt1.x,&Pt1.y);
               cputs("\r\nHeight (Bigger than 0) : ");
               scanf("%lf",&Hei);
               cputs("\r\nRotation Angle (0 to 359): ");
               scanf("%lf",&Ang);
               cputs("\r\nText to display: ");
               fflush(stdin);
               gets(Str);
               /*Set Just automatically to Left Justified or Default */
               Just=RIGHT;
               break;
         case 's':
         case 'S':
         default:
               cputs("\r\nLeft Justified Text (default) ");  
               cputs("\r\nText Line Start Point (e.g 10,10) : ");
               scanf("%lf,%lf",&Pt1.x,&Pt1.y);
               cputs("\r\nHeight (Bigger than 0) : ");
               scanf("%lf",&Hei);
               cputs("\r\nRotation Angle (0 to 359): ");
               scanf("%lf",&Ang);
               cputs("\r\nText to display: ");
               fflush(stdin);
               gets(Str);
               /*Set Just automatically to Left Justified or Default */
               Just=DEFAULT;
               break;
      }
      ginitgraphics(); /* graphic initialization */
     
      OuttextState=Text(Str, Just, Pt1, Pt2, Hei, Ang*(3.1415/180.0),BufferFonts );
      PutDisplay(); /* Output to display */
      
     
     getch();
      inittextmode(); /* go back to text mode */
      cputs("\r\n\r\nExit to DOS (Y/N) <N>" );
      Com=getch();
      if(Com=='y'||Com=='Y')
         break;
   }while(1);
   free((void*)BufferFonts);     /*Temporaly*/
}
/*-----------------------------------------------------------------------*/
void PutDisplay(void);
void PutDisplay(void)
{
   unsigned long i;
   int y=tg_getmaxy();



   /* Trace from the first element in the table (0) to the last one (defined)
      in the variable LastPrimitiveIndex returned by Text(), LastPrimitiveIndex 
      is updated wen the Text() function is called 
    */  
   
   for(i=0;i<DisplayIndex;i++)
      {
       if(Display[i].OpCode==PFMOVETO)
         _moveto((short)Display[i].x,y-(short)Display[i].y);  /* y- stands for invertin axes */
       else
          {
           _setcolor(7);
           _lineto((short)Display[i].x,y-(short)Display[i].y);  /* y- stands for invertin axes */
          }
      }
}                    
/*-----------------------------------------------------------------*/
int inittextmode(void);
int inittextmode(void)
{
  _setvideomode(_DEFAULTMODE);
  _settextcolor(7);
  _settextposition(1,1);
  return(0);
}
/*---------------------------------------------------------------------*/
/* Returns the max number of pixels in y cood */
int tg_getmaxy(void); 
int tg_getmaxy(void)
{                
struct videoconfig config;

  _getvideoconfig(&config);
   return(config.numypixels);
}

/*---------------------------------------------------------------------*/
int ginitgraphics(void);
int ginitgraphics(void)
{                
  _settextcolor(7);
  _settextposition(1,1);
  _clearscreen(_GCLEARSCREEN);
  if (_setvideomode(_VRES16COLOR))
   return(_VRES16COLOR);
  if (_setvideomode(_ERESCOLOR))
   return(_ERESCOLOR);
  if (_setvideomode(_HERCMONO))
   return(_HERCMONO);
  else
   return(0);
}
/*---------------------------------------------------------------------*/

/*------------------------------------------------------------------------*/
int FontFileExists(char *FontFile);
int FontFileExists(char *FontFile)
{
struct find_t Buffer;
return(!_dos_findfirst(FontFile,_A_NORMAL,&Buffer));
}

/*-------------------------------------------------------*/
size_t FontFileSize(char *FontFile);
size_t FontFileSize(char *FontFile)
{
struct find_t Buffer;
_dos_findfirst(FontFile,_A_NORMAL,&Buffer);
return((size_t)Buffer.size);
}
/*------------------------------------------------------------------------*/



